#include <stdio.h>
#include <stdlib.h>

int n;

int pidgeon (int i, int j) { return n * (i-1) + j; }

int main (int argc, char ** argv) {

  if (argc != 2) {
    fprintf (stderr, "*** permute: expected exactly one argument\n");
    exit (1);
  }

  n = atoi (argv[1]);

  if (n < 2) {
    fprintf (stderr, "*** permute: invalid argument '%s'\n", argv[1]);
    exit (1);
  }

  printf ("p cnf %d %d\n", n*n, n*n*(n-1)/2 + n);

  for (int i = 1; i <= n; i++)
    for (int j = 1; j <= n; j++)
      for (int k = j + 1; k <= n; k++)
	printf ("%d %d 0\n", -pidgeon (j, i), -pidgeon (k, i));

  for (int i = 1; i <= n; i++) {
    for (int j = 1; j <= n; j++)
      printf ("%d ", pidgeon (i, j));
    printf ("0\n");
  }

  return 0;
}
